#include "include.h"
#include <unistd.h>
#include "device.h"
#include <scsi/sg.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

//Gotta ask ali1234 how this works... This piece of code is supposed to send
//the device from usb storage mode to firmware upgrade mode, but it doesn't 
//do that yet...
int sendtofwmode(char* dev) {
    int f;
    sg_io_hdr h;
    unsigned char b[1];
    
    b[0]=0xcb;
    memset(&h,0,sizeof(h));
    h.interface_id='S';
    h.cmd_len=12;
    h.dxfer_direction = SG_DXFER_FROM_DEV;
    h.dxfer_len = 1;
    h.dxferp =b;
    h.cmdp=b;
    f=open(dev,O_RDWR);
    ioctl(f,SG_IO,&h);
    perror("scsi:");
    sleep(2);
}

int main(int argc, char** argv) {
    HANDLE h;
    char data[0x8000];
    int f;
    char membuff[65536];
    unsigned int nobytes;
    CMD c;
    int n;
    //0x3400 is an ECC checking scratchpad, so we should be able to safely use it
    unsigned int toaddr=0x3400;

    if (argc!=2) {
	printf("Usage: %s file.bin",argv[0]);
    }

//Doesn't work yet    
//    sendtofwmode("/dev/sg4");

    memset(&c,0,sizeof(c));
    h=device_open('a');


/*
    //Inquire device type
    c.mode = 0x80;
    c.cmd = 0x8905;
    c.size = 0x1000; 
    c.unkwn0x13=1<<24; 
    c.unkwn0x17=1<<24;
    device_send_cmd(h, &c, (void *)data, c.size);
    for (n=0; n<0xc0; n++) {
	printf("%02hhx ",data[n]);
	if (data[n]>31) printf("%c",data[n]);
    }
    printf("\n");
*/

//The following code contains quite a few 'magic numbers'. These are gleaned
//from usb logs from a firmware update by the original Windows-programs.
//I'm not sure if all the magic really is necessary, but let's keep it until
//we're sure.

    //Upload program to RAM
    printf("Reading & uploading program...\n");
    f=open(argv[1],O_RDONLY);
    nobytes=read(f,membuff,65536);
    printf("%i bytes read.\n",nobytes);
    //Pad to a multiple of 256 bytes.
    //Hw can prolly handle less granular transfers, this is just for the easy-factor.
    nobytes+=255; nobytes=nobytes&0xff00; 
    close(f);
    printf("Padded to %i (0x%x) bytes.\n",nobytes,nobytes);
    c.mode = 0x0;
    c.cmd = 0x3005+(toaddr<<16);
    c.size = nobytes; 
    c.unkwn0x13=(8<<16)+0xcb03; //page 0
    c.unkwn0x17=0x4100+(nobytes>>8);
    device_send_cmd(h, &c, (void *)membuff, nobytes);
    //and run
    printf("Running the program...\n");
    c.mode = 0xf8;
    c.cmd = 0xa0000020+(toaddr<<8);
    c.size = 0; 
    c.unkwn0x13=0x80000;
    c.unkwn0x17=0xe57000;
    device_send_cmd(h, &c, (void *)membuff, 0);

    printf("Done.\n");
    device_close(&h);
    return 0;
}